## qtav 1.12.0%2Bds

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MULTIARCH ?= $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)
export QT_SELECT=qt5

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --parallel --buildsystem qmake

override_dh_auto_configure:
	dh_auto_configure -Sqmake -- CONFIG+="no_rpath recheck config_libass_link config_openal_link no-tests"
