=== debian/changelog ===
qtav (1.12.0+ds-5) unstable; urgency=medium

  * Team upload.
  * Switch Vcs-* fields to salsa.debian.org.
  * Bump the debhelper compatibility to 11:
    - bump the debhelper build dependency to 11~
    - bump compat to 11
    - remove --parallel for dh, as now done by default
  * Bump Standards-Version to 4.1.5, no changes required.
  * Fix build with FFmpeg >= 4.0. (Closes: #888367)
  * Remove empty line at the end of rules.

 -- Pino Toscano <pino@debian.org>  Wed, 18 Jul 2018 09:12:03 +0200

qtav (1.12.0+ds-4) unstable; urgency=medium

  * Team upload.
  * Disable libva-dev on Hurd, since it is not available there.
  * Try to load the libva* libraries with SONAME 2 (Closes: #880884)

 -- Pino Toscano <pino@debian.org>  Thu, 23 Nov 2017 19:55:30 +0100

qtav (1.12.0+ds-3) unstable; urgency=medium

  * Team upload.

  [ Steve M. Robbins ]
  * Update standards-version to 4.1.1.  Add Vcs-* fields.

  [ Pino Toscano ]
  * Remove manual library and va-driver dependencies. (Closes: #880884)
  * Specify the buildsystem as qmake.
  * Use dh_auto_configure in its override.
  * Link in as-needed mode.

 -- Pino Toscano <pino@debian.org>  Fri, 10 Nov 2017 22:36:00 +0100

qtav (1.12.0+ds-2) unstable; urgency=medium

  * [3bbd7b5] Declare libqtav1 and libqtavwidgets1 as Section: libs
  * [a1046d3] Mark qtav-players as multi-arch "no" since binaries are
    installed into not-arch-specific directory /usr/lib/qt5/bin.

 -- Steve M. Robbins <smr@debian.org>  Sat, 04 Nov 2017 21:36:00 -0500

qtav (1.12.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #737016)

 -- Steve M. Robbins <smr@debian.org>  Sun, 27 Aug 2017 23:06:54 -0500
