=== debian/rules ===
--- 
+++ 
@@ -6,8 +6,7 @@
 export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
 
 %:
-	dh $@ --parallel --buildsystem qmake
+	dh $@ --buildsystem qmake
 
 override_dh_auto_configure:
 	dh_auto_configure -Sqmake -- CONFIG+="no_rpath recheck config_libass_link config_openal_link no-tests"
-
