=== debian/changelog ===
qtav (1.12.0.1+ds+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Debian Qt extras Maintainers <debian-qt-kde@lists.debian.org>  Fri, 29 Jan 2021 09:15:15 +0800
