## qtav 1.13.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,9 @@
 cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)
+
+project(QTAV)
+
 set(QTAV_MAJOR 1)
-set(QTAV_MINOR 11)
+set(QTAV_MINOR 13)
 set(QTAV_PATCH 0)
 set(PROJECT_VERSION ${QTAV_MAJOR}.${QTAV_MINOR}.${QTAV_PATCH})
 set(SO_VERSION ${QTAV_MAJOR})
@@ -10,6 +13,9 @@
 
 if(POLICY CMP0063) # visibility. since 3.3
   cmake_policy(SET CMP0063 NEW)
+endif()
+if(POLICY CMP0071)
+  cmake_policy(SET CMP0071 NEW)
 endif()
 set(CMAKE_CXX_VISIBILITY_PRESET hidden) #use with -fdata-sections -ffunction-sections to reduce target size
 set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)
