=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -101,7 +101,7 @@
   set(MODULE QMLPlayer)
   if(WIN32)
     set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MODULE}.rc)
-    configure_file(${CMAKE_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
+    configure_file(${QTAV_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
   endif()
   add_executable(QMLPlayer ${EXE_TYPE}
       QMLPlayer/main.cpp
@@ -120,7 +120,7 @@
   set(MODULE Player)
   if(WIN32)
     set(RC_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MODULE}.rc)
-    configure_file(${CMAKE_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
+    configure_file(${QTAV_SOURCE_DIR}/cmake/QtAV.rc.in ${RC_FILE})
   endif()
   add_executable(Player ${EXE_TYPE} ${PLAYER_SRC} ${PLAYER_HEADERS} ${PLAYER_RES} ${RC_FILE})
   target_link_libraries(Player QtAVWidgets common)
