=== src/CMakeLists.txt ===
--- 
+++ 
@@ -12,8 +12,8 @@
 include_directories(${QTDIR}/include) #TODO: remove. use external/include
 get_filename_component(QTDIR "${QTDIR}" ABSOLUTE)
 
-list(APPEND EXTRA_INCLUDE ${CMAKE_SOURCE_DIR}/external/include)
-list(APPEND EXTRA_LIBS ${CMAKE_LIBRARY_PATH_FLAG}${CMAKE_SOURCE_DIR}/external/lib)
+list(APPEND EXTRA_INCLUDE ${QTAV_SOURCE_DIR}/external/include)
+list(APPEND EXTRA_LIBS ${CMAKE_LIBRARY_PATH_FLAG}${QTAV_SOURCE_DIR}/external/lib)
 if(APPLE)
     if(IOS)
       #set_xcode_property(myioslib IPHONEOS_DEPLOYMENT_TARGET "8.0")
@@ -22,9 +22,9 @@
       list(APPEND EXTRA_LIBS -L/usr/local/lib)
     endif()
 endif()
-if(EXISTS ${CMAKE_SOURCE_DIR}/contrib/capi/capi.h)
+if(EXISTS ${QTAV_SOURCE_DIR}/contrib/capi/capi.h)
     set(HAVE_CAPI 1)
-    list(APPEND EXTRA_INCLUDE ${CMAKE_SOURCE_DIR}/contrib/capi) # TODO: only files use capi.h
+    list(APPEND EXTRA_INCLUDE ${QTAV_SOURCE_DIR}/contrib/capi) # TODO: only files use capi.h
     list(APPEND EXTRA_DEFS -DQTAV_HAVE_CAPI=1)
 endif()
 
@@ -324,7 +324,7 @@
 if(WIN32 OR WindowsStore OR WindowsPhone)
   check_include_files(XAudio2.h HAVE_XAUDIO2_H)
   if(NOT HAVE_XAUDIO2_H)
-    list(APPEND EXTRA_INCLUDE ${CMAKE_SOURCE_DIR}/contrib/dxsdk)
+    list(APPEND EXTRA_INCLUDE ${QTAV_SOURCE_DIR}/contrib/dxsdk)
   endif()
   message("Qt5Gui_EGL_INCLUDE_DIRS: ${Qt5Gui_EGL_INCLUDE_DIRS}")
   list(APPEND HEADERS
