=== debian/changelog ===
qtav (1.13.0+ds-4build1) jammy; urgency=medium

  * No-change rebuild against Qt 5.15.3.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Thu, 17 Mar 2022 18:37:53 +0300

qtav (1.13.0+ds-4) unstable; urgency=medium

  * Team upload.

  [ Sebastian Ramacher ]
  * debian/control: Build-Depend on libswresample-dev instead of
    libavresample-dev (Closes: #971329)

  [ Pino Toscano ]
  * Bump Standards-Version to 4.6.0, no changes required.
  * Add the configuration for the CI on salsa.
  * Remove the explicit as-needed linking, as it is done by binutils now.
  * Drop query for DEB_BUILD_MULTIARCH in rules, as it is not used.
  * Add Rules-Requires-Root: no.
  * Switch the debhelper build dependency to debhelper-compat (same version)
    - remove debian/compat

 -- Pino Toscano <pino@debian.org>  Sat, 21 Aug 2021 12:32:50 +0200

qtav (1.13.0+ds-3) unstable; urgency=medium

  * Team upload.
  * Backport upstream patch to add missing include for Qt 5.15.
    (Closes: #972355)

 -- Dmitry Shachnev <mitya57@debian.org>  Wed, 21 Oct 2020 13:10:45 +0300

qtav (1.13.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Backport upstream patch to add missing include for Qt 5.14.
    (Closes: #960951)
  * Remove Section field for qtav-players that duplicates source.
  * Use spaces instead of tabs for indentation in debian/control.

 -- Dmitry Shachnev <mitya57@debian.org>  Tue, 02 Jun 2020 19:30:30 +0300

qtav (1.13.0+ds-1) unstable; urgency=medium

  [ Steven Robbins ]
  * [4ef3ad4] New upstream version 1.13.0+ds

 -- Steve M. Robbins <smr@debian.org>  Sat, 31 Aug 2019 18:20:39 -0500
