=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Steve M. Robbins <smr@debian.org>
 Section: video
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 11),
                qt5-qmake,
                libqt5opengl5-dev,
                libqt5svg5-dev,
@@ -11,11 +11,11 @@
                libqt5x11extras5-dev,
                libass-dev,
                libavutil-dev,
-               libavresample-dev,
                libavcodec-dev,
                libavformat-dev,
                libavdevice-dev,
                libavfilter-dev,
+               libswresample-dev,
                libswscale-dev,
                libopenal-dev,
                libpulse-dev,
@@ -23,7 +23,8 @@
                libva-dev [!hurd-any],
                libegl1-mesa-dev,
                libuchardet-dev
-Standards-Version: 4.1.5
+Standards-Version: 4.6.0
+Rules-Requires-Root: no
 Homepage: http://qtav.org
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/qtav
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/qtav.git
@@ -99,13 +100,12 @@
 Package: qtav-players
 Architecture: any
 Multi-Arch: no
-Section: video
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          qml-module-qtav,
-	 qml-module-qtquick-dialogs,
-	 qml-module-qtquick-controls,
-	 qml-module-qt-labs-folderlistmodel
+         qml-module-qtquick-dialogs,
+         qml-module-qtquick-controls,
+         qml-module-qt-labs-folderlistmodel
 Pre-Depends: ${misc:Pre-Depends}
 Description: QtAV/QML players
  QtAV is a multimedia playback framework based on Qt and FFmpeg.
